#!/usr/bin/perl
###########################################################################
# Copyright 2003-2005 UNINETT AS
# http://www.uninett.no
#
# This file is part of Nemo.
#
# Nemo is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# Nemo is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Nemo; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###########################################################################

# Reads the url file and adds all the urls to the Nemo database
# By Gunnar Gauslaa Bergem, June 2003

use strict;

require "nemo_db.pl";

my $url_file = '/local/net-status/kart/uninett/drs/url-mal/url.alle';
#my $url_file = '/local/net-status/kart/uninett/drs/url.alle';

my $net = 'uninett';
my $dbh = DBI->connect($NemoDB::dsn, $NemoDB::user, $NemoDB::password);
if (!$dbh) {die "Error: Can not connect to database."}

my $file;
my $sth;
my $line;
my $url_info;
my $verbose = 0;

while ($#ARGV >= 0) {
    if ($ARGV[0] =~ /-verbose/) {
	shift(@ARGV);
	$verbose = 1;
    }
    else {
	shift(@ARGV);
    }
}

open (URL_FILE, $url_file) or die $!;
$sth = $dbh->prepare("DELETE FROM location_url");
$sth->execute();
$sth = $dbh->prepare("DELETE FROM line_url");
$sth->execute();

while (defined ($line = <URL_FILE>)) {    
    if ($line =~ /^INFO\s+(.+)/) {
        $url_info = $1;
        print "URL info: $url_info\n" if $verbose;
    }
    if ($line =~ /^PUNKT\s(\S+)\s(\S+)/) {
        my $location = $1;
        my $url = $2;
        my $mod_url_info = $url_info;
        # if the url contains a | at the end, extract the last part and use it in url_info
        if ($url =~ /(\S+)\|(\S+)/) {
            $mod_url_info = $url_info." ".$2;
            $url = $1;
            print "Modified URL info: $mod_url_info\n" if $verbose;
        }
        $sth = $dbh->prepare("SELECT location_id FROM location WHERE location_name = '$location' ".
            "AND net = '$net'");
        $sth->execute();
        my $location_id = ($sth->fetchrow_array())[0];
        
        if (defined $location_id) {
            $sth = $dbh->prepare("SELECT COUNT(*) FROM location_url WHERE location_id = '$location_id' AND ".
                "net = '$net' AND link = '$url'");
            $sth->execute();
            my $num_rows = ($sth->fetchrow_array())[0];
            if ($num_rows == 0) {
                $sth = $dbh->prepare("INSERT INTO location_url VALUES ('$net', '$location_id', '$url', '$mod_url_info')");
                $sth->execute();
            }
        }
    }
    if ($line =~ /^LINJE\s(\S+)\s(\S+)/) {
        my $line = $1;
        my $url = $2;
        $sth = $dbh->prepare("SELECT line_id FROM line WHERE line_name = '$line'");
        $sth->execute();
        my $line_id = ($sth->fetchrow_array())[0];
        
        if (defined $line_id) {
            $sth = $dbh->prepare("SELECT COUNT(*) FROM line_url WHERE line_id = '$line_id' AND ".
                "net = '$net' AND link = '$url'");
            $sth->execute();
            my $num_rows = ($sth->fetchrow_array())[0];
            if ($num_rows == 0) {
                $sth = $dbh->prepare("INSERT INTO line_url VALUES ('$net', '$line_id', '$url', '$url_info')");
                $sth->execute();
            }
        }
    }
}

close (URL_FILE);
$sth->finish();
$dbh->disconnect();
