#! /usr/bin/perl
###########################################################################
# Copyright 2003-2005 UNINETT AS
# http://www.uninett.no
#
# This file is part of Nemo.
#
# Nemo is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# Nemo is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Nemo; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###########################################################################

#Prints out lines which are different in the Nemo and the Stager
#By Simon Jonassen, July 2005
use strict;

require "nemo_db.pl";
require "timelocal.pl";

my $nemo_sth;
my $netflow_sth;

my $net = 'uninett';
my $nemo_dbh = DBI->connect($NemoDB::dsn, $NemoDB::user, $NemoDB::password);
if (!$nemo_dbh) {die "Error: Can not connect to Nemo database."}

my $netflow_dsn = 'DBI:Pg:dbname=stager;host=netflowdata.uninett.no;port=5433';
my $netflow_usr = 'stager';
my $netflow_pw = 'Stag56er';
my $netflow_dbh = DBI->connect($netflow_dsn, $netflow_usr, $netflow_pw);
if (!$netflow_dbh) {die "Error: Can not connect to Netflow database."}

my $reverse=0;
my $line_id;
my $rev_line_name;
my $line_name;
my $tot_cnt=0;
my $m_cnt=0;
my $u_cnt=0;
my $wchar="";

while ($#ARGV >= 0) {
    if ($ARGV[0] =~ /-reverse/) {
	shift(@ARGV);
	$reverse = 1;
    }
    elsif ($ARGV[0] =~ /-wchars/){
	shift(@ARGV);
	$wchar = "%";
    }
    else {
        shift(@ARGV);
	die "Invalid argument. Usage:\n linkdiff [-reverse] [-wchars]";
    }
}

if ($reverse){
	print "From netflow to nemo!\n";
	$netflow_sth = $netflow_dbh->prepare("SELECT DISTINCT name FROM obs_point_descr where name<>''");
	$netflow_sth->execute();
	while ($line_name = ($netflow_sth->fetchrow_array())[0]) {
		if ($line_name =~ /([\w\d]+)-([\w\d]+)/) {
			$rev_line_name = "$2"."-"."$1";
		}
		$nemo_sth = $nemo_dbh->prepare("SELECT line_id FROM line WHERE line_name LIKE '$wchar$line_name$wchar'");
		$nemo_sth->execute();
		$line_id = ($nemo_sth->fetchrow_array())[0];
		$nemo_sth->finish();
		
		if(!defined $line_id and defined $rev_line_name){
			$nemo_sth = $nemo_dbh->prepare("SELECT line_id FROM line WHERE line_name LIKE '$wchar$rev_line_name$wchar'");
			$nemo_sth->execute();
			$line_id = ($nemo_sth->fetchrow_array())[0];
			$nemo_sth->finish();
		}
	 
		if (!defined $line_id) {
			print "$line_name";
			print " and $rev_line_name" if $rev_line_name;
			print " not found\n";
			$u_cnt++;
		} else {
			$m_cnt++;
		}
		$tot_cnt++;
	}
	$netflow_sth->finish();
} else {
	print "From nemo to netflow!\n";
	$nemo_sth = $nemo_dbh->prepare("SELECT DISTINCT line_name FROM line");
	$nemo_sth->execute();
	while ($line_name = ($nemo_sth->fetchrow_array())[0]) {
		if ($line_name =~ /([\w\d]+)-([\w\d]+)/) {
			$rev_line_name = "$2"."-"."$1";
		}
	
		$netflow_sth = $netflow_dbh->prepare("SELECT ifindex FROM obs_point_descr WHERE name LIKE '$wchar$line_name$wchar'");
		$netflow_sth->execute();
		$line_id = ($netflow_sth->fetchrow_array())[0];
		$netflow_sth->finish();
		if(!defined $line_id and defined $rev_line_name){
			$netflow_sth = $netflow_dbh->prepare("SELECT ifindex FROM obs_point_descr WHERE name LIKE '$wchar$rev_line_name$wchar'");
			$netflow_sth->execute();
			$line_id = ($netflow_sth->fetchrow_array())[0];
			$netflow_sth->finish();
		}
	 
		if (!defined $line_id) {
			print "$line_name";
			print " and $rev_line_name" if $rev_line_name;
			print " not found\n";
			$u_cnt++;
		} else {
			$m_cnt++;
		}
		$tot_cnt++;
	}
	$nemo_sth->finish();
}
print "Totals: $tot_cnt lines, where $m_cnt is ok and $u_cnt is not !\n";

$netflow_dbh->disconnect();
$nemo_dbh->disconnect();
