#!/usr/bin/perl
###########################################################################
# Copyright 2003-2005 UNINETT AS
# http://www.uninett.no
#
# This file is part of Nemo.
#
# Nemo is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# Nemo is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Nemo; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###########################################################################

# Reads statcolours.conf and updates the database accordingly with the
# new values.
# By Gunnar Gauslaa Bergem, January 2005

use strict;

require "nemo_db.pl";

my $dbh = DBI->connect($NemoDB::dsn, $NemoDB::user, $NemoDB::password);
if (!$dbh) {die "Error: Can not connect to database."}

my $sth;
my $line;
my $statistic_name;
my $updated_records = 0;

open (CONFIG_FILE, 'statcolours.conf') or die $!;

while (defined ($line = <CONFIG_FILE>)) {
    if ($line =~ /^STATNAME\s+([\w\s()\/]+)$/) {
	$statistic_name = $1;
	chomp($statistic_name);
	$sth = $dbh->prepare("DELETE FROM conversion WHERE stat_name = '$statistic_name'");
	$sth->execute();
	print "Updating statistic '$statistic_name'\n";
    }
    if ($line =~ /(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s?([\d\w\s<>()\-\/]*)$/) {
	my $interval_start = $1;
	my $interval_end = $2;
	my $red = $3;
	my $green = $4;
	my $blue = $5;
	my $label = $6;

	$sth = $dbh->prepare("INSERT INTO conversion (stat_name, interval_start, interval_end, colour, label) VALUES ".
			     "('$statistic_name', '$interval_start', '$interval_end', '$red $green $blue', '$label')");
	$sth->execute();
	$updated_records++;
    }
}

print "$updated_records records read from config file and updated in database.\n";
$sth->finish();
$dbh->disconnect();
