/*
 * PointStatistic.java
 *
 * Created on July 4, 2003, 10:41 AM
 */

import java.awt.*;
import javax.swing.*;

/**
 * The PointStatistic class contains values such as colour and size for a point
 * so that it can be drawn correctly on the map.
 * 
 * @author Gunnar Gauslaa Bergem
 */
public class PointStatistic {
    private String statisticType;
    private String statisticDescription;
    private Color colour;
    private ImageIcon symbol;
    private int size;
    private String pointName;
    private int timestamp;
    
    /** Creates a new instance of PointStatistic */
    public PointStatistic(String type, String description, String name, int timestamp) {
        statisticType = type;
        statisticDescription = description;
        pointName = name;
        this.timestamp = timestamp;
    }
    
    public PointStatistic(String type, String description, String name, int timestamp, Color colour) {
        this(type, description, name, timestamp);
        this.colour = colour;
    }
    
    public PointStatistic(String type, String description, String name, int timestamp, int size) {
        this(type, description, name, timestamp);
        this.size = size;
    }
    
    public String getPointName() {
        return pointName;
    }
    
    public Color getColour() {
        return colour;
    }
    
    public int getSize() {
        return size;
    }
    
    public String getType() {
        return statisticType;
    }
    
    public String getDescription() {
        return statisticDescription;
    }
    
    public int getTimestamp() {
        return timestamp;
    }
}
