import javax.jnlp.BasicService;
import javax.jnlp.ServiceManager;
import javax.jnlp.UnavailableServiceException;
import javax.sound.midi.SysexMessage;
import javax.swing.*;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.*;

public class PopupMenu extends JPopupMenu implements ActionListener{ 
	private ArrayList keys, values;
	private Selectable owner;
	private MapFrame mapf;
	
	public PopupMenu(Selectable owner,MapFrame mapf){
		this.owner=owner;
		this.mapf=mapf;
		JMenuItem itm=new JMenuItem("Show statistics...");
		itm.addActionListener(this);
		this.add(itm);
		this.addSeparator();
		
	}
	
	public void addURLkeys(ArrayList keys){
		this.keys=keys;		
		for(int i=0; i<keys.size();i++){
			JMenuItem item=new JMenuItem((String)keys.get(i));
			item.addActionListener(this);
			this.add(item);
		}
	}
	public void addURLvalues(ArrayList values){
		this.values=values;
	}
	
	public void actionPerformed(ActionEvent evt){
		String cmd=evt.getActionCommand();
		NemoUtils.debug(cmd);
		if (cmd.equals("Show statistics...")) 
			owner.showStatistics(mapf,null);
		else
		for (int i=0;i<keys.size();i++){
			if (keys.get(i).equals(cmd)){
				String val=(String) values.get(i);	
				try {
		           BasicService bs = (BasicService)ServiceManager.lookup("javax.jnlp.BasicService");
		           bs.showDocument(new URL(val));
		        } catch(UnavailableServiceException ue) {
		           System.err.println("Browser service not available.\n");
		        }
		           catch (MalformedURLException me){
		           System.err.println("Invalid url.\n");
		        }
				
			}
		}
	}

}
